// Author: GingerGoat69

package strongholdfinder;

public class Intersection
{
	public static Vector GetIntersection(Vector v1s, Vector v1e, Vector v2s, Vector v2e) throws NotEnoughPresicionException
    {
        double v1k = (v1e.y - v1s.y) / (v1e.x - v1s.x);
        double v2k = (v2e.y - v2s.y) / (v2e.x - v2s.x);
        
        double v1m = v1s.y + v1k * (0 - v1s.x);
        double v2m = v2s.y + v2k * (0 - v2s.x);

        double intrsectX;
        
        if(v1k == Double.POSITIVE_INFINITY || v1k == Double.NEGATIVE_INFINITY)
        {
        	intrsectX = v1s.x;
        }
        else if(v2k == Double.POSITIVE_INFINITY || v2k == Double.NEGATIVE_INFINITY)
        {
        	intrsectX = v2s.x;
        }
        else
        {
        	intrsectX = (v2m - v1m) / (v1k - v2k);
        }
        
        double intrsectY = v1k * intrsectX + v1m;
        
        if(!Double.isFinite(intrsectX) || !Double.isFinite(intrsectY))
        {
        	throw new NotEnoughPresicionException("Lines are parallel!", "Stronghold is either too far away, or the distance between the two enderpearls is too small.");
        }
        
        return new Vector(intrsectX, intrsectY);
    }
}
